declare const _default: {
    left: {
        x: number;
        opacity: number;
    };
    right: {
        x: number;
        opacity: number;
    };
    top: {
        y: number;
        opacity: number;
    };
    bottom: {
        y: number;
        opacity: number;
    };
    alpha: {
        opacity: number;
    };
    scale: {
        scale: number;
        opacity: number;
    };
    scaleBig: {
        scale: number;
        opacity: number;
    };
    scaleX: {
        opacity: number;
        scaleX: number;
    };
    scaleY: {
        opacity: number;
        scaleY: number;
    };
    'mask-bottom': {
        opacity: number;
        scale: number;
        y: string;
    };
    'mask-top': {
        opacity: number;
        scale: number;
        y: string;
    };
    flash: {
        enter: ({
            opacity: number;
            type: string;
            duration: number;
        } | {
            opacity: number;
            duration: number;
            type?: undefined;
        })[];
        leave: {
            opacity: number;
            duration: number;
        }[];
    };
    bounce: {
        enter: ({
            opacity: number;
            type: string;
            y?: undefined;
            duration?: undefined;
        } | {
            y: number;
            opacity: number;
            duration: number;
            type?: undefined;
        } | {
            y: number;
            duration: number;
            opacity?: undefined;
            type?: undefined;
        })[];
        leave: ({
            y: number;
            duration: number;
            opacity?: undefined;
        } | {
            y: number;
            opacity: number;
            duration: number;
        })[];
    };
    swing: {
        enter: ({
            opacity: number;
            type: string;
            x?: undefined;
            duration?: undefined;
        } | {
            x: number;
            opacity: number;
            duration: number;
            type?: undefined;
        } | {
            x: number;
            duration: number;
            opacity?: undefined;
            type?: undefined;
        })[];
        leave: ({
            x: number;
            duration: number;
            opacity?: undefined;
        } | {
            x: number;
            opacity: number;
            duration: number;
        })[];
    };
    'swing-rotate': {
        enter: ({
            opacity: number;
            transformOrigin: string;
            type: string;
            rotate?: undefined;
            duration?: undefined;
        } | {
            rotate: number;
            opacity: number;
            duration: number;
            transformOrigin?: undefined;
            type?: undefined;
        } | {
            rotate: number;
            duration: number;
            opacity?: undefined;
            transformOrigin?: undefined;
            type?: undefined;
        })[];
        leave: ({
            rotate: number;
            duration: number;
            opacity?: undefined;
        } | {
            rotate: number;
            opacity: number;
            duration: number;
        })[];
    };
    'swing-y': {
        enter: ({
            opacity: number;
            type: string;
            y?: undefined;
            duration?: undefined;
        } | {
            y: number;
            opacity: number;
            duration: number;
            type?: undefined;
        } | {
            y: number;
            duration: number;
            opacity?: undefined;
            type?: undefined;
        })[];
        leave: ({
            y: number;
            duration: number;
            opacity?: undefined;
        } | {
            y: number;
            opacity: number;
            duration: number;
        })[];
    };
};
export default _default;
